

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.9. grn_db &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.25.10. grn_encoding" href="grn_encoding.html" />
    <link rel="prev" title="7.25.8. grn_ctx" href="grn_ctx.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/api/grn_db.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="grn_encoding.html" title="7.25.10. grn_encoding"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="grn_ctx.html" title="7.25.8. grn_ctx"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.9. </span><code class="docutils literal notranslate"><span class="pre">grn_db</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-db">
<h1><span class="section-number">7.25.9. </span><code class="docutils literal notranslate"><span class="pre">grn_db</span></code><a class="headerlink" href="#grn-db" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.9.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>TODO...</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.9.2. </span>例<a class="headerlink" href="#example" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>TODO...</p>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.9.3. </span>リファレンス<a class="headerlink" href="#reference" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>TODO...</p>
<dl class="c type">
<dt id="c.grn_db">
<em class="property">type </em><code class="sig-name descname">grn_db</code><a class="headerlink" href="#c.grn_db" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>TODO...</p>
</dd></dl>

<dl class="c type">
<dt id="c.grn_db_create_optarg">
<em class="property">type </em><code class="sig-name descname">grn_db_create_optarg</code><a class="headerlink" href="#c.grn_db_create_optarg" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p><a class="reference internal" href="#c.grn_db_create" title="grn_db_create"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_db_create()</span></code></a> のオプションを指定するために使います。</p>
</dd></dl>

<dl class="c member">
<dt id="c.grn_db_create_optarg.builtin_type_names">
char **<code class="sig-prename descclassname"><a class="reference internal" href="#c.grn_db_create_optarg" title="grn_db_create_optarg">grn_db_create_optarg</a><code class="sig-prename descclassname">.</code></code><code class="sig-name descname">builtin_type_names</code><a class="headerlink" href="#c.grn_db_create_optarg.builtin_type_names" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>組み込み型の名前となるnul終端文字列の配列を指定する。</p>
</dd></dl>

<dl class="c member">
<dt id="c.grn_db_create_optarg.n_builtin_type_names">
int <code class="sig-prename descclassname"><a class="reference internal" href="#c.grn_db_create_optarg" title="grn_db_create_optarg">grn_db_create_optarg</a><code class="sig-prename descclassname">.</code></code><code class="sig-name descname">n_builtin_type_names</code><a class="headerlink" href="#c.grn_db_create_optarg.n_builtin_type_names" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>n_builtin_type_namesには、optarg.builtin_type_namesで指定する文字列の数を
指定する。配列のoffsetはenum型grn_builtin_typeの値に対応する。</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_create">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_db_create</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <em class="property">const</em> char *<em>path</em>, <a class="reference internal" href="#c.grn_db_create_optarg" title="grn_db_create_optarg">grn_db_create_optarg</a> *<em>optarg</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_create" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>新たなdbを作成します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- 初期化済みの <a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> を指定します。</p></li>
<li><p><strong>path</strong> -- 作成するdbを格納するファイルパスを指定します。NULLならtemporary dbとなります。NULL以外のパスを指定した場合はpersistent dbとなります。</p></li>
<li><p><strong>optarg</strong> -- <p>Currently, it is not used. It is just ignored.</p>
<p>作成するdbの組み込み型の名前を変更する時に指定します。</p>
<p>optarg.builtin_type_namesには、組み込み型の名前となるnull終端文字列の配列を指定します。optarg.n_builtin_type_namesには、optarg.builtin_type_namesで指定する文字列の数を指定します。配列のoffsetはenum型grn_builtin_typeの値に対応します。</p>
</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_open">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_db_open</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <em class="property">const</em> char *<em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_open" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>既存のdbを開きます。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>path</strong> -- 開こうとするdbを格納するファイルパスを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_touch">
void <code class="sig-name descname">grn_db_touch</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_touch" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>dbの内容の最終更新時刻を現在時刻にします。</p>
<p>最終更新時刻はキャッシュが有効かどうかの判断などに利用されます。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> -- 内容が変更されたdbを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_db">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_obj_db</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_db" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>objの属するdbを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> -- 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_recover">
grn_rc <code class="sig-name descname">grn_db_recover</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_recover" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><div class="admonition note">
<p class="admonition-title">注釈</p>
<p>これは実験的なAPIです。</p>
</div>
<div class="admonition note">
<p class="admonition-title">注釈</p>
<p>This is a dangerous API. You must not use this API when other
thread or process opens the target database. If you use this API
against shared database, the database may be broken.</p>
</div>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 4.0.9 で追加.</span></p>
</div>
<p>Checks the passed database and recovers it if it is broken and it
can be recovered.</p>
<p>This API uses lock existence for checking whether the database is
broken or not.</p>
<p>以下は復旧可能なケースです。</p>
<blockquote>
<div><ul class="simple">
<li><p>Index column is broken. The index column must have source column.</p></li>
</ul>
</div></blockquote>
<p>以下は復旧できないケースです。</p>
<blockquote>
<div><ul class="simple">
<li><p>Object name management feature is broken.</p></li>
<li><p>Table is broken.</p></li>
<li><p>Data column is broken.</p></li>
</ul>
</div></blockquote>
<p>Object name management feature is used for managing table name,
column name and so on. If the feature is broken, the database can't
be recovered. Please re-create the database from backup.</p>
<p>Table and data column can be recovered by removing an existence
lock and re-add data.</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> -- 復旧対象のデータベース。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_unmap">
grn_rc <code class="sig-name descname">grn_db_unmap</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_unmap" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><div class="admonition note">
<p class="admonition-title">注釈</p>
<p>これは実験的なAPIです。</p>
</div>
<div class="admonition note">
<p class="admonition-title">注釈</p>
<p>This is a thread unsafe API. You can't touch the database while
this API is running.</p>
</div>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 5.0.7 で追加.</span></p>
</div>
<p>Unmaps all opened tables and columns in the passed
database. Resources used by these opened tables and columns are
freed.</p>
<p>Normally, this API isn't useless. Because resources used by opened
tables and columns are managed by OS automatically.</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> -- 復旧対象のデータベース。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.9. <code class="docutils literal notranslate"><span class="pre">grn_db</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.9.1. 概要</a></li>
<li><a class="reference internal" href="#example">7.25.9.2. 例</a></li>
<li><a class="reference internal" href="#reference">7.25.9.3. リファレンス</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="grn_ctx.html"
                        title="前の章へ"><span class="section-number">7.25.8. </span><code class="docutils literal notranslate"><span class="pre">grn_ctx</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="grn_encoding.html"
                        title="次の章へ"><span class="section-number">7.25.10. </span><code class="docutils literal notranslate"><span class="pre">grn_encoding</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="grn_encoding.html" title="7.25.10. grn_encoding"
             >次へ</a> |</li>
        <li class="right" >
          <a href="grn_ctx.html" title="7.25.8. grn_ctx"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.9. </span><code class="docutils literal notranslate"><span class="pre">grn_db</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>